package de.bsvrz.vew.bmvew.bmvew.regel;

import java.util.Vector;

import de.bsvrz.dav.daf.main.ClientDavInterface;
import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.DataDescription;
import de.bsvrz.dav.daf.main.DataNotSubscribedException;
import de.bsvrz.dav.daf.main.ResultData;
import de.bsvrz.dav.daf.main.SendSubscriptionNotConfirmed;
import de.bsvrz.dav.daf.main.SenderRole;
import de.bsvrz.dav.daf.main.Data.TextArray;
import de.bsvrz.dav.daf.main.Data.TextValue;
import de.bsvrz.dav.daf.main.config.Aspect;
import de.bsvrz.dav.daf.main.config.AttributeGroup;
import de.bsvrz.dav.daf.main.config.ConfigurationObject;
import de.bsvrz.dav.daf.main.config.DataModel;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.sys.funclib.debug.Debug;
import de.bsvrz.vew.bmvew.bmvew.BetriebsMeldungApp;
import de.bsvrz.vew.bmvew.bmvew.sender.Sender;

/**
 * Die Klasse implementiert das Ausfuehr-Verhalten Verteilen 
 *
 * @version $Revision: 1.2 $ / $Date: 2010/09/14 10:08:10 $ / ($Author: Pittner $)
 *
 * @author Dambach-Werke GmbH
 * @author Timo Pittner
 *
 */
public class AusfuehrenEmail implements AktionAusfuehrVerhalten 
{

  /**
   * Der Debugger
   */
  Debug _debug;
  
  /**
   * Das Feld der Parametertexte
   */  
  TextArray _parameter;
  
  /**
   * Der Aktionstext
   */
  TextValue _aktion; 
  
  
  /**
   * Der Separator zwischen den Adressen
   */
  final String _separator = ";"; 
  
  
  /**
   * Konstruktor
   * 
   * @param parameter
   *          Feld der Parametertexte
   * @param aktion
   *          Aktionstext
   */
  public AusfuehrenEmail(TextArray parameter, TextValue aktion)
  {
    // TODO Auto-generated constructor stub
    if (aktion == null || parameter == null)
      throw new IllegalArgumentException();
    
    _parameter = parameter;
    _aktion = aktion;
    _debug = Debug.getLogger();
  }

  /* (non-Javadoc)
   * @see de.bsvrz.vew.bmvew.bmvew.regel.AktionAusfuehrVerhalten#ausfuehrenAktion(de.bsvrz.dav.daf.main.ResultData)
   */
  public boolean ausfuehrenAktion(ResultData betriebsMeldung)
  {
    // TODO Auto-generated method stub
    ClientDavInterface con = BetriebsMeldungApp.getConnection();
    DataModel model = BetriebsMeldungApp.getConnection().getDataModel();
    
    AttributeGroup atg = model.getAttributeGroup("atg.emailVersandAuftrag");
    Aspect asp = model.getAspect("asp.auftrag");
    DataDescription dd = new DataDescription(atg, asp);
    Data data = con.createData(atg);
    
    ConfigurationObject conf = BetriebsMeldungApp.getVersandObjekt();
     
    String absender = betriebsMeldung.getData().getItem("ApplikationsKennung").asTextValue().getText();                  
//    long id = betriebsMeldung.getData().getItem("ApplikationsID").asScaledValue().longValue();
    long nummer = betriebsMeldung.getData().getItem("LaufendeNummer").asScaledValue().longValue();
    long id = BetriebsMeldungApp.getConnection().getLocalApplicationObject().getId();
//    long nummer = BetriebsMeldungApp.getNextLaufendeNummerEmailFax();     
    
//    if (nummer > 0)
//    nummer -= 1;
    
    String text = betriebsMeldung.getData().getItem("MeldungsText").asTextValue().getText();
       
    data.getItem("MeldungsID").getItem("ApplikationsID").asScaledValue().set(id);
    data.getItem("MeldungsID").getItem("LaufendeNummer").asScaledValue().set(nummer);
    

    String[] array = _parameter.getTextArray();
    
    StringBuffer buff = new StringBuffer();
    
    for (int i = 0; i < array.length; i++)
    {
      String s = array[i];
      
      buff.append(s);
      
      if (array.length > 1 && i < array.length-1)
        buff.append(_separator);
    }
    
    data.getItem("Empfaenger").asTextValue().setText(buff.toString());

    data.getItem("Absender").asTextValue().setText(absender);
    data.getItem("Betreff").asTextValue().setText("");
    data.getItem("Text").asTextValue().setText(text);
    
    // versende Email
    _debug.fine("Aktion -> " + _aktion.getText() + " versende Email " + data + " fr : " + conf.getPid());
    
    Vector<ResultData> sendeDaten = BetriebsMeldungApp.getSendeDaten();
    ResultData res = new ResultData(conf, dd, System.currentTimeMillis(), data);
    
    synchronized (sendeDaten)
    {
      sendeDaten.add(res);        
      sendeDaten.notify();
    }
    
//    Sender sender = new Sender(con, SenderRole.sender());
//    sender.sende(conf, atg, asp, data);
    
    return true;
  }

}
